var codes = {"refreshInterval":10,"fillType":"Fit","size":{"width":630,"height":248},"buttons":[{"nameColor":"rgba(0,0,0,1.000000)","bgImageURL":null,"output":"3 206","x":93,"outputTextOffset":{"x":50,"y":16},"y":19,"border":{"color":"rgba(38,89,140,1.000000)","width":1},"outputMovieURL":null,"outputColor":"rgba(0,0,0,1.000000)","wrapText":false,"bgColor":"rgba(69,163,230,1.000000)","height":32,"name":null,"nameFont":"12px \"Helvetica\", sans-serif","outputFont":"12px \"Helvetica\", sans-serif","nameTextOffset":{"x":0,"y":0},"width":100,"opacity":1},{"nameColor":"rgba(0,0,0,1.000000)","bgImageURL":null,"output":"4","x":182,"outputTextOffset":{"x":50,"y":16},"y":74,"border":{"color":"rgba(38,89,140,1.000000)","width":1},"outputMovieURL":"movies\/5b9ac230cf58c86468e44f6f3487577a.mov","outputColor":"rgba(0,0,0,1.000000)","wrapText":false,"bgColor":"rgba(69,163,230,1.000000)","height":32,"name":null,"nameFont":"12px \"Helvetica\", sans-serif","outputFont":"12px \"Helvetica\", sans-serif","nameTextOffset":{"x":0,"y":0},"width":100,"opacity":1},{"nameColor":"rgba(0,0,0,1.000000)","bgImageURL":"images\/b8626132477bda53c50daeef263a30b4.png","output":null,"x":316,"outputTextOffset":{"x":0,"y":0},"y":70,"border":{"color":"rgba(0,0,0,1.000000)","width":1},"outputMovieURL":null,"outputColor":"rgba(0,0,0,1.000000)","wrapText":false,"bgColor":"rgba(214,214,214,1.000000)","height":177,"name":"Code Button","nameFont":"12px \"Helvetica\", sans-serif","outputFont":"12px \"Helvetica\", sans-serif","nameTextOffset":{"x":157,"y":88},"width":314,"opacity":1}],"bgColor":"rgba(255,255,255,1.000000)"};

function popUp(movieURL) {
var shadowing = document.getElementById('shadowing');
var box = document.getElementById('box');
var content = document.getElementById('boxcontent');
content.style.padding="0";
content.innerHTML = "<center><video autoplay controls width='90%' height='90%' id='video'> <source src='"+movieURL+"' type='video/mp4'> Unsupported video format! </video></center>";
shadowing.style.display='block';
box.style.display='block';
}

function toggleVideoPlayback()
{
var video = document.getElementById("video");

if (!video.paused) {
	video.pause();
	}
else {
	video.play();
	}
}

function closebox()
{
var video = document.getElementById("video");
video.pause();
var shadowing = document.getElementById('shadowing');
var box = document.getElementById('box');
shadowing.style.display='none';
box.style.display='none';
}
function isChrome() {
return (navigator.userAgent.toLowerCase().indexOf('chrome') > -1);
}

function isFileScheme() {
return (window.location.href.toLowerCase().indexOf('file://') > -1);
}

(function(window) {
var SC = {};

/**
* ImageCache class
*/
(function(SC){
SC.ImageCache = function () {
this.cache = {};
this.imagesBeingLoaded = {};
}

SC.ImageCache.prototype.existingImageAtURL = function(imageURL){
var foundImg = this.cache[imageURL];
if(foundImg)
return foundImg;
else
return null;

}

SC.ImageCache.prototype.loadImageAtURL = function(imageURL, callback){
var existingImg = this.existingImageAtURL(imageURL);
if(existingImg){
//already loaded, so callback immediately
callback(existingImg);
} else {
var existingCallbacks = this.imagesBeingLoaded[imageURL];
if(existingCallbacks){
//loading has already begun, just add callback to existing list
existingCallbacks.push(callback);
} else {
//start loading the image
this.imagesBeingLoaded[imageURL] = [callback];

var myImagesBeingLoaded = this.imagesBeingLoaded;
var myCache = this.cache;

var img = new Image();
img.onload = function(){
myCache[imageURL] = img;
var allCallbacks = myImagesBeingLoaded[imageURL];
myImagesBeingLoaded[imageURL] = undefined;
allCallbacks.forEach(function(callback) {
callback(img);
});
};
img.src = imageURL;
}
}
}
})(SC); //end ImageCache

/**
* CodeWindow class
*/
(function(SC){
SC.CodeWindow = function(canvasElement, codeWindowJsonURL) {
if(typeof codeWindowJsonURL !== 'string' || codeWindowJsonURL.length <= 0)
throw "Invalid json url argument";
if(!canvasElement || typeof canvasElement !== 'object' || canvasElement.tagName !== 'CANVAS')
throw "Invalid canvas element argument";

var _canvas = canvasElement;
var _jsonURL = codeWindowJsonURL;
var _imageCache = new SC.ImageCache();
var _lastReceivedCodeWindowJSON = undefined;
var _keepUpdating = false;
var _codeWindow = [];

function _getElementPageOffset(elem){
var curleft = curtop = 0;
if (elem.offsetParent) {
do {
curleft += elem.offsetLeft;
curtop += elem.offsetTop;
} while (elem = elem.offsetParent);
}
return {x: curleft, y: curtop};
}

function _getLocalMouseEventPoint(e, elem) {
var posx = 0;
var posy = 0;
if (!e) var e = window.event;
if (e.pageX || e.pageY) {
posx = e.pageX;
posy = e.pageY;
} else if (e.clientX || e.clientY)     {
posx = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
posy = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
}
var elemOffset = _getElementPageOffset(elem);
return {x: posx - elemOffset.x, y: posy - elemOffset.y};
}

function _clickableButtonForMouseEvent(e) {
var p = _getLocalMouseEventPoint(e, _canvas);
for(var i=0, a=_codeWindow.buttons, len=a.length; b=a[len - i -1], i<len; i++) {
if(b.outputMovieURL){
if(p.x >= b.x && p.x <= b.x + b.width && p.y >= b.y && p.y <= b.y + b.height){
return b;
}
}
}
return null;
}

_canvas.onclick = function(e){
var b = _clickableButtonForMouseEvent(e);
if(b && b.outputMovieURL){
var ctx = _canvas.getContext('2d');
ctx.fillStyle = 'rgba(0,0,0,0.3)';
ctx.fillRect(b.x, b.y, b.width, b.height);
ctx = undefined;

popUp(b.outputMovieURL);

console.log('Clicked: ' + b.outputMovieURL);

for(var i=0, a=_codeWindow.buttons, len=a.length; b=a[i], i<len; i++) {
b.isDrawn = false;
}
setTimeout(_drawButtons, 200);
}
}

_canvas.onmousemove = function(e){
var b = _clickableButtonForMouseEvent(e);
_canvas.style.cursor = (b ? 'pointer' : 'default');
}

var _codeWindowReceived = function(codeWindowJSON){
if(!_keepUpdating) return;

if(codeWindowJSON !== _lastReceivedCodeWindowJSON){
_codeWindow = codeWindowJSON;
_canvas.width = _codeWindow.size.width + 1;
_canvas.height = _codeWindow.size.height + 1;

_loadButtonImages();
_drawBackgroundColor();
_drawBackgroundImage();
_drawButtons();
}

_lastReceivedCodeWindowJSON = codeWindowJSON;
}

var _requestCodeWindow = function() {
var req = new XMLHttpRequest();
req.open('GET', _jsonURL + "?=_"+(new Date().getTime()), true);
if(_codeWindow && _codeWindow.lastModified){
req.setRequestHeader('If-Modified-Since', _codeWindow.lastModified);
}
req.onreadystatechange = function () {
if(req.readyState === 4){
if(req.status === 200 || req.status === 0){
_codeWindowReceived(JSON.parse(req.responseText));
_codeWindow.lastModified = req.getResponseHeader('Last-Modified');
}
req = undefined;
if(_keepUpdating){
var refreshMilis = (_codeWindow ? _codeWindow.refreshInterval : 10) * 1000;
if(refreshMilis >= 0){
setTimeout(_requestCodeWindow, refreshMilis);
}
}
}
};
req.send(null);
}

var _requestCodeWindowLocally = function() {
_codeWindowReceived(codes);
}

var _loadButtonImages = function() {
for(var i=0, a=_codeWindow.buttons, len=a.length; b=a[i], i<len; i++) {
if(b.bgImageURL && !b.bgImage){
(function(buttonToLoad){
_imageCache.loadImageAtURL(buttonToLoad.bgImageURL, function(img){
buttonToLoad.bgImage = img;
_drawButtons(); //redraw everything when an image is loaded
});
})(b);
}
}
}

var _drawBackgroundColor = function() {
var body = document.getElementsByTagName('body')[0];
if(body.className === "vigital-default-html"){
body.style.cssText = "background-color: " + _codeWindow.bgColor + ";";
}
}

var _drawBackgroundImage = function() {
var body = document.getElementsByTagName('body')[0];
if(body.className === "vigital-default-html"){
if (_codeWindow.bgImageURL){
body.style.cssText += "background-image: url(" + _codeWindow.bgImageURL + ");";
if (_codeWindow.fillType == "None"){
body.style.cssText += "background-repeat: no-repeat;";
}else if (_codeWindow.fillType == "Fill"){
body.style.cssText += "background-repeat: no-repeat;";
body.style.cssText += "background-size: 100% 100%";
}else if (_codeWindow.fillType == "Fit"){
body.style.cssText += "background-repeat: no-repeat;";
body.style.cssText += "background-size: contain;";
}else if (_codeWindow.fillType == "Tile"){
body.style.cssText += "background-repeat: repeat;";
}
}
}
}

var _lineHeight = function(text, context) {
var tmp = document.createElement('span');
tmp.textContent = text;
tmp.style.font = context.font;
tmp.style.whiteSpace = 'nowrap';
tmp.style.visibility = 'hidden';
tmp.style.position = 'absolute';

body = document.getElementsByTagName('body')[0];
body.appendChild(tmp);
var lineHeight = tmp.offsetHeight;
body.removeChild(tmp);

return lineHeight;
}

var _lineBreakText = function(text, context, lineWidth){
var words = text.split(" ");
var line = "";
var allLines = [];

for(var n = 0; n < words.length; ++n) {
var testLine = line + (line.length > 0 ? ' ' : '') + words[n];
var metrics = context.measureText(testLine);
if(metrics.width > lineWidth) {
if(line.length > 0){
//this line is done
allLines.push({
text: line,
height: _lineHeight(line, context)
});
//rerun this iteration again, starting with a blank line
line = '';
n -= 1;
} else {
//first word on line is too long, so split word onto multiple lines
var partialWord = '';
for(var charIdx = 0; charIdx < words[n].length; ++charIdx){
var nextChar = words[n].substr(charIdx, 1);
if(context.measureText(partialWord + nextChar).width > lineWidth){
allLines.push({
text: partialWord,
height: _lineHeight(partialWord, context)
});
partialWord = nextChar;
} else {
partialWord += nextChar;
}
}

//if there is some of the word left, rerun this iteration of the loop
//with the remainder of the word
if(partialWord.length > 0){
words[n] = partialWord;
n -= 1;
}
}
} else {
//don't break line, because it's not long enough yet
line = testLine;
}
}

if(line.length > 0){
allLines.push({
text: line,
height: _lineHeight(line, context)
});
}

return allLines;
}

var _drawText = function(text, context, centerPoint, button){
context.textAlign = "center";
context.textBaseline = "middle";
centerX = button.x + centerPoint.x;
centerY = button.y + (button.height - centerPoint.y);
if(button.wrapText){
//break into lines
var allLines = _lineBreakText(text, context, button.width);

//reset centerY to first line
var totalHeight = 0;
for(var i = 0; i < allLines.length - 1; ++i){
totalHeight += allLines[i].height;
}
centerY -= totalHeight / 2.0;

//draw all lines
for(var i = 0; i < allLines.length; ++i){
var line = allLines[i];
context.fillText(line.text, centerX, centerY);
centerY += line.height;
}
} else {
context.fillText(text, centerX, centerY);
}
}

var _drawButtons = function() {
var canvasContext = _canvas.getContext('2d');
var buttons = _codeWindow.buttons;
for(var buttonsLen = buttons.length, i = 0; i < buttonsLen; ++i){
var b = buttons[i];
if(!b.isDrawn){
if(!b.bgImageURL || b.bgImage){
_drawButton(b, canvasContext);
b.isDrawn = true;
} else {
break; //stop drawing, the button hasn't been loaded fully
}
}
}

cavasContext = undefined;
}

var _drawButton = function(button, context) {
if(button.opacity <= 0) return;
context.globalAlpha = button.opacity ? button.opacity : 1;

var midX = button.x + (button.width / 2);
var midY = button.y + (button.height / 2);

//background
if(button.bgImage){
context.drawImage(button.bgImage, button.x, button.y, button.width, button.height);
} else {
context.fillStyle = button.bgColor;
context.fillRect(button.x, button.y, button.width, button.height);
}

//border
if(button.border){
context.strokeStyle = button.border.color;
context.lineWidth = button.border.width;
context.strokeRect(button.x + 0.5, button.y + 0.5, button.width, button.height);
}

//name
if(button.name){
context.fillStyle = button.nameColor;
context.font = button.nameFont;
_drawText(button.name, context, button.nameTextOffset, button);
}

//output
if(button.output){
context.fillStyle = button.outputColor;
context.font = button.outputFont;
_drawText(button.output, context, button.outputTextOffset, button);
}
}

this.startUpdating = function(){
if(_keepUpdating) return; //already started

_keepUpdating = true;
if(isChrome() && isFileScheme()) {
_requestCodeWindowLocally();
console.log('Load json locally');
} else {
_requestCodeWindow();
console.log('Load remote json');
}
}

this.stopUpdating = function(){
_keepUpdating = false;
}
}
})(SC); //end CodeWindow

//expose SC to global scope
window.SC = SC;

})(window); //end SC
